import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;


public class Settings implements CommandListener {

    private RecordStore rs;
    private List set;
    private String[] op_title = Translator.default_op_title;
    private String[] op_ind = Translator.default_op_ind;
    private Command sel_all;
    private Command des_all;
    private Command back;
    private Command ok;
    
    public Settings(){
        sel_all = new Command("Отм. все",Command.SCREEN,3);
        des_all = new Command("Снять все",Command.SCREEN,4);
        back = new Command("Назад",Command.BACK,2);
        ok = new Command("Ok", Command.OK, 1);
        set = new List("Рабочие языки",List.MULTIPLE,op_title, null);
        set.addCommand(sel_all);
        set.addCommand(des_all);
        set.addCommand(back);
        set.addCommand(ok);
        set.setCommandListener(this);
        set_all(true);
    }

    public void start(){
        Main.disp.setCurrent(set);
    }

    public void save(){
        int i,k = 0;
        Vector result_op_title = new Vector();
        Vector result_op_ind = new Vector();

        for (i=0;i<op_ind.length;i++){
            if (set.isSelected(i)==true){
                result_op_title.addElement(op_title[i]);
                result_op_ind.addElement(op_ind[i]);
                k++;
            }
        }

        if (k<1){
            int n = 1;
            while (true){
                if (set.isSelected(n)==false){
                    result_op_title.addElement(op_title[n]);
                    result_op_ind.addElement(op_ind[n]);
                    break;
                }
                n++;
            }
        }

        ByteArrayOutputStream boutput = new ByteArrayOutputStream();
        DataOutputStream doutput = new DataOutputStream(boutput);
        try{
            doutput.writeInt(result_op_title.size());
            for(i=0;i<result_op_title.size();i++){
                doutput.writeUTF((String)result_op_title.elementAt(i));
            }
        }
        catch (IOException ioe){}
        byte[] data = boutput.toByteArray();
        boutput = null;
        doutput = null;

        try{
            rs = RecordStore.openRecordStore("array",false);
            rs.setRecord(2,data,0,data.length);
            rs.closeRecordStore();
        }
        catch (RecordStoreException rse){}
        data = null;


        boutput = new ByteArrayOutputStream();
        doutput = new DataOutputStream(boutput);

        try{
            doutput.writeInt(result_op_ind.size());
            for(i=0;i<result_op_ind.size();i++){
                doutput.writeUTF((String)result_op_ind.elementAt(i));
            }
        }
        catch (IOException ioe){}
        data = boutput.toByteArray();
        boutput = null;
        doutput = null;

        try{
            rs = RecordStore.openRecordStore("array",false);
            rs.setRecord(1,data,0,data.length);
            rs.closeRecordStore();
        }
        catch (RecordStoreException rse){}
        data = null;

        Main.translator.readrms();
        Main.translator.refresh();
        Main.translator.start();
    }

    public void set_all(boolean select){
        for (int i=0;i<op_ind.length;i++){
            set.setSelectedIndex(i, select);
        }
    }

    public void commandAction(Command c, Displayable d){
        if (d==set){
            if (c==back){Main.translator.start();}
            if (c==List.SELECT_COMMAND||c==ok){save();}
            if (c==sel_all){set_all(true);}
            if (c==des_all){set_all(false);}
        }
    }
}
